﻿using System;
using System.Collections.Generic;
using System.Linq;

using System.Data;
using System.Data.Common;
using System.Data.SqlClient;
using System.Data.Sql;
using MSXML2;
using System.Xml;
using System.Configuration;
namespace UFIDA.U8.Portal.GuaZhangQueR
{
    public static class SqlHelper
    {
        
        static SqlConnection connection;

        public static string ConnectionString = "";
        public static SqlConnection iConnection(string connectionString)
        {
            try
            {
                if (connection == null)
                {
                    connection = new SqlConnection(connectionString);
                    connection.Open();
                }
                else if (connection.State == System.Data.ConnectionState.Closed)
                {
                    connection.Open();
                }
                else if (connection.State == System.Data.ConnectionState.Broken)
                {
                    connection.Close();
                    connection.Open();
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.ToString());
            }
            return connection;
        }
       
        public static SqlDataReader GetReader(string ConnectionString, string strSQL)
        {
            SqlConnection conn = new SqlConnection(ConnectionString);
            SqlCommand cmd = new SqlCommand(strSQL, conn);
            try
            {
                conn.Open();
                //我们添加枚举CommandBehavior.CloseConnection之后，将来reader对象的链接会跟随reader对象的关闭自动关闭
                return cmd.ExecuteReader(CommandBehavior.CloseConnection);
            }
            catch (Exception ex)
            {
                //可以在这个地方捕获ex对象相关信息，然后保存到日志文件中...
                throw new Exception("执行方法 public static object GetSingleResult(string sql)发生异常：" + ex.Message);
            }
            //finally  //在这个方法里面，绝对不能直接把链接关掉，否则出错
            //{
            //    conn.Close();
            //}
        }

        public static int ExecuteNonQuery(string ConnectionString, string strsql)
        {
            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    SqlCommand cmd = new SqlCommand(strsql, connection);
                    int result = cmd.ExecuteNonQuery();

                    return result;
                }
            }
            catch (Exception ex)
            {
                throw new Exception(strsql + ex.ToString());
            }
        }
        /// <summary>
        /// 执行sql语句，并返回错误信息
        /// </summary>
        /// <param name="ConnectionString">sql链接串</param>
        /// <param name="strsql">sql业务脚本</param>
        /// <param name="msg">返回信息，如果返回空则成功，否则返回具体的错误信息</param>
        /// <returns>-1为系统错误</returns>
        public static int ExecuteNonQueryResult(string ConnectionString, string strsql)
        {
            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    SqlCommand cmd = new SqlCommand(strsql, connection);
                    int result = cmd.ExecuteNonQuery();
                    return result;
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Sql:" + strsql + "Error：" + ex.ToString());
            }
        }
        public static DataTable GetDataTableCheckRows(string ConnectionString, string safeSql)
        {
            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    DataSet ds = new DataSet();
                    SqlCommand cmd = new SqlCommand();
                    cmd.Connection = connection;
                    cmd.CommandText = safeSql;
                    SqlDataAdapter da = new SqlDataAdapter(cmd);
                    da.Fill(ds);
                    if (ds.Tables[0].Rows.Count < 1)
                    {
                        throw new Exception("Sql:" + safeSql + "Error：无数据！！");
                    }
                    return ds.Tables[0];
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Sql:" + safeSql + "Error：" + ex.ToString());
            }
            //finally
            //{
            //    connection.Close();
            //}
        }

        public static DataTable GetDataTable(string safeSql)
        {

            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    DataSet ds = new DataSet();
                    SqlCommand cmd = new SqlCommand();
                    cmd.Connection = connection;
                    cmd.CommandText = safeSql;
                    SqlDataAdapter da = new SqlDataAdapter(cmd);
                    da.Fill(ds);
                    return ds.Tables[0];
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Sql:" + safeSql + "Error：" + ex.ToString());
            }
        }


        public static DataTable GetDataTable(string ConnectionString, string safeSql)
        {

            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    DataSet ds = new DataSet();
                    SqlCommand cmd = new SqlCommand();
                    cmd.Connection = connection;
                    cmd.CommandText = safeSql;
                    SqlDataAdapter da = new SqlDataAdapter(cmd);
                    da.Fill(ds);
                    return ds.Tables[0];
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Sql:" + safeSql + "Error：" + ex.ToString());
            }
        }

        public static string ExecuteNonQueryString(string ConnectionString, string safeSql)
        {
            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    SqlCommand cmd = new SqlCommand(safeSql, connection);

                    if (cmd.ExecuteScalar().ToString() != null)
                    {
                        return cmd.ExecuteScalar().ToString();
                    }
                    return "";
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Sql:" + safeSql + "Error：" + ex.ToString());
            }
        }

        public static SqlDataReader GetDateReader(string ConnectionString, string safeSql)
        {

            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    SqlCommand cmd = new SqlCommand(safeSql, connection);
                    SqlDataReader reader = cmd.ExecuteReader();

                    return reader;
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Sql:" + safeSql + "Error：" + ex.ToString());
            }
        }

        public static DataTable ProcGetDataTables(string procname, out string msg, params SqlParameter[] values)
        {
            try
            {
                DataSet ds = new DataSet();
                using (SqlConnection Connection = new SqlConnection(ConnectionString))
                {
                    SqlCommand cmd = new SqlCommand();
                    cmd.Connection = Connection;
                    cmd.CommandText = procname;
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.AddRange(values);
                    SqlDataAdapter adapter = new SqlDataAdapter(cmd);
                    adapter.Fill(ds);
                    if (ds.Tables.Count > 0)
                    {
                        msg = "";
                        return ds.Tables[0];
                    }
                    else
                    {
                        msg = "无数据";
                        return null;
                    }
                }
            }
            catch (Exception ex)
            {
                msg = ex.ToString();
                return null;
            }
        }

        public static SqlDataReader GetReader(string ConnectionString, string safeSql, params SqlParameter[] values)
        {

            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    SqlCommand cmd = new SqlCommand(safeSql, connection);
                    cmd.Parameters.AddRange(values);
                    SqlDataReader reader = cmd.ExecuteReader();
                    return reader;
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Sql:" + safeSql + "Error：" + ex.ToString());
            }
        }

        /// <summary>
        /// 传入公式得到计算结果
        /// </summary>
        /// <param name="xmlRow">xml行记录，如表体的某行，是公式获取值的基础</param>
        /// <param name="Formula">具体要计算的公式</param>
        /// <returns>计算结果string</returns>
        public static string GetFormula(XmlElement xmlRow, string Formula)
        {
            string strFormula;
            string strcompute;
            strcompute = "";
            strFormula = Formula;
            //strFormula = "(|isamount|*|ipayamoun|)+|itax|";
            string[] sArray = strFormula.Split('|');
            for (int i = 0; i < sArray.Count(); i++)
            {
                if (i % 2 == 1)
                {
                    if (xmlRow.GetAttribute(sArray[i].ToString()).Trim() == "")
                    {
                        strcompute = strcompute + "0";
                    }
                    else
                    {
                        strcompute = strcompute + xmlRow.GetAttribute(sArray[i].ToString());
                    }
                }
                else
                {
                    strcompute = strcompute + sArray[i].ToString();
                }
            }
            strcompute = new DataTable().Compute(strcompute, null).ToString();
            double dbcompute = Math.Round(double.Parse(strcompute), 6);
            return dbcompute.ToString();
        }

        /// <summary>
        /// 传入公式得到计算结果  类型为xmlNode
        /// </summary>
        /// <param name="xmlRow">xml行记录，如表体的某行，是公式获取值的基础</param>
        /// <param name="Formula">具体要计算的公式</param>
        /// <returns>计算结果string</returns>
        public static string GetFormula(IXMLDOMNode xmlRow, string Formula)
        {
            string strFormula;
            string strcompute;
            strcompute = "";
            strFormula = Formula;
            IXMLDOMElement de = (IXMLDOMElement)xmlRow;
            //strFormula = "(|isamount|*|ipayamoun|)+|itax|";
            string[] sArray = strFormula.Split('|');
            for (int i = 0; i < sArray.Count(); i++)
            {
                if (i % 2 == 1)
                {
                    if (de.getAttribute(sArray[i].ToString()).ToString().Trim() == "")
                    {
                        strcompute = strcompute + "0";
                    }
                    else
                    {
                        strcompute = strcompute + de.getAttribute(sArray[i].ToString()).ToString().Trim();
                    }
                }
                else
                {
                    strcompute = strcompute + sArray[i].ToString();
                }
            }
            strcompute = new DataTable().Compute(strcompute, null).ToString();
            double dbcompute = Math.Round(double.Parse(strcompute), 6);
            return dbcompute.ToString();
        }
        public static int ExecuteNonQuery(string ConnectionString, string sql, params SqlParameter[] values)
        {

            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    SqlCommand cmd = new SqlCommand(sql, connection);
                    cmd.Parameters.AddRange(values);
                    int result = cmd.ExecuteNonQuery();
                    cmd.Parameters.Clear();
                    return result;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        /// <summary>
        /// 执行sql语句，有记录返回1无返回0，异常-1
        /// </summary>
        /// <param name="ConnectionString"></param>
        /// <param name="strsql"></param>
        /// <param name="msg">如有错误存储错误信息，否则返回空</param>
        /// <returns>1有记录0无记录-1异常</returns>
        public static int ExecuteScalar(string ConnectionString, string strsql)
        {

            int result = 0;
            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    SqlCommand cmd = new SqlCommand(strsql, connection);
                    SqlDataReader dr = cmd.ExecuteReader();
                    if (dr.HasRows)
                    {
                        result = 1;
                    }
                    return result;
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Sql:" + strsql + "Error：" + ex.ToString());
            }
        }
        public static DataTable ProcGetDataTables(string procname, params SqlParameter[] values)
        {
            try
            {
                DataSet ds = new DataSet();
                using (SqlConnection Connection = new SqlConnection(ConnectionString))
                {
                    SqlCommand cmd = new SqlCommand();
                    cmd.Connection = Connection;
                    cmd.CommandText = procname;
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.AddRange(values);
                    SqlDataAdapter adapter = new SqlDataAdapter(cmd);
                    adapter.Fill(ds);
                    if (ds.Tables.Count > 0)
                    {

                        return ds.Tables[0];
                    }
                    else
                    {
                        return null;
                    }
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.ToString());
            }
        }
        /// <summary>
        /// 给定连接串、存储过程名称，如是存储过程里是update数据，更新到了行，返回1，没更新到记录返回0
        /// </summary>
        /// <param name="ConnectionString"></param>
        /// <param name="ProcName"></param>
        /// <param name="msg"></param>
        /// <param name="values"></param>
        /// <returns></returns>
        public static DataTable ExecuteProcCommand(string ProcName, params SqlParameter[] values)
        {

            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    DataSet ds = new DataSet();
                    connection.Open();
                    SqlCommand cmd = new SqlCommand();
                    cmd.Connection = connection;
                    cmd.CommandText = ProcName;
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.AddRange(values);
                    SqlDataAdapter da = new SqlDataAdapter(cmd);
                    da.Fill(ds);
                    return ds.Tables[0];
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Sql:" + ProcName + "Error：" + ex.ToString());

            }
        }

        public static int ExecuteCommand(string ConnectionString, string safeSql)
        {

            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    SqlCommand cmd = new SqlCommand(safeSql, connection);
                    int result = cmd.ExecuteNonQuery();

                    return result;
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Sql:" + safeSql + "Error：" + ex.ToString());
            }
        }
        public static int ExecuteSqlTran(string ConnectionString, List<string> sqllist)
        {
            try
            {
                int rtint = 0;
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    SqlCommand cmd = new SqlCommand();
                    SqlTransaction mytran = connection.BeginTransaction();

                    //绑定数据库连接和事务对象
                    cmd.Connection = connection;
                    cmd.Transaction = mytran;
                    try
                    {
                        foreach (string sql in sqllist)
                        {
                            cmd.CommandText = sql;
                            rtint = cmd.ExecuteNonQuery();
                        }
                        mytran.Commit();

                        return rtint;
                    }
                    catch (Exception ex)
                    {
                        throw new Exception(ex.ToString());
                    }
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.ToString());

            }
        }
        public static DataTable ProcGetDataTables(string ConnectionString, string procname, out string msg, params SqlParameter[] values)
        {
            try
            {
                DataSet ds = new DataSet();
                using (SqlConnection Connection = new SqlConnection(ConnectionString))
                {
                    SqlCommand cmd = new SqlCommand();
                    cmd.Connection = Connection;
                    cmd.CommandText = procname;
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.AddRange(values);
                    SqlDataAdapter adapter = new SqlDataAdapter(cmd);
                    adapter.Fill(ds);
                    if (ds.Tables.Count > 0)
                    {
                        msg = "";
                        return ds.Tables[0];
                    }
                    else
                    {
                        msg = "无数据";
                        return null;
                    }
                }
            }
            catch (Exception ex)
            {
                msg = ex.ToString();
                return null;
            }
        }
        public static int ExecuteCommand(string ConnectionString, string sql, params SqlParameter[] values)
        {

            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    SqlCommand cmd = new SqlCommand(sql, connection);
                    cmd.Parameters.AddRange(values);
                    int result = cmd.ExecuteNonQuery();

                    return result;
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.ToString());
            }
        }
        /// <summary>
        /// 执行sql语句，并返回错误信息 jiangb20170718
        /// </summary>
        /// <param name="ConnectionString">sql链接串</param>
        /// <param name="strsql">sql业务脚本</param>
        /// <param name="msg">返回信息，如果返回空则成功，否则返回具体的错误信息</param>
        /// <returns>-1为系统错误</returns>
        public static int NExecuteNonQueryResult(string strsql)
        {
            try
            {
                using (SqlConnection connection = new SqlConnection(ConnectionString))
                {
                    connection.Open();
                    SqlCommand cmd = new SqlCommand(strsql, connection);
                    int result = cmd.ExecuteNonQuery();
                    return result;
                }
            }
            catch (Exception ex)
            {
                throw new Exception("Sql:" + strsql + "Error：" + ex.ToString());
            }
        }
        /// <summary>
        /// 主要用于执行主表和明细表类型
        /// </summary>
        /// <param name="ConnectionString"></param>
        /// <param name="strsql"></param>
        /// <returns></returns>
        public static int ExecuteTrans(string ConnectionString, string strHeadSql, string strBodySql)
        {
            int OrderID;
            int iRow;//返回执行条数
            iRow = 0;
            SqlTransaction Transaction = null;
            using (SqlConnection conn = new SqlConnection(ConnectionString))
            {
                conn.Open();
                //开启事务  
                Transaction = conn.BeginTransaction();
                SqlCommand cmd = new SqlCommand();
                cmd.Transaction = Transaction;
                cmd.Connection = conn;
                cmd.CommandType = CommandType.Text;
                cmd.CommandText = strHeadSql;
                OrderID = Convert.ToInt32(cmd.ExecuteScalar());
                strBodySql = strBodySql.Replace("replaceid", OrderID.ToString());
                cmd.CommandText = strBodySql;
                iRow = cmd.ExecuteNonQuery();
                //事务提交  
                Transaction.Commit();
                return iRow;
            }
        }
    }
}
